package org.jboss.tutorial.entity.client;

import java.util.Collection;

import javax.naming.InitialContext;

import org.jboss.tutorial.entity.bean.Customer;
import org.jboss.tutorial.entity.bean.CustomerManager;

public class ClientCreate
{
  public static void main(String[] args) 
    throws Exception
  {
    // Obtain a reference to the remote CustomerManagerBean
    InitialContext ctx = new InitialContext();
    CustomerManager cm = (CustomerManager) ctx.lookup("CustomerManagerBean/remote");
    
    // Create five new customers in the database
    createCustomer(cm, 1, "Burr", "Sutter");
    createCustomer(cm, 2, "Stan", "Silvert");
    createCustomer(cm, 3, "Pete", "Bennett");
    createCustomer(cm, 4, "Peter", "Wang");
    createCustomer(cm, 5, "Nazem", "Attar");
    
    // Now let's see what we have
    Collection<Customer> customers = cm.findAllCustomers();
    for(Customer c : customers) 
    {
      System.out.println(c);
    }
  }
  
  private static void createCustomer(CustomerManager cm, 
                                     int id, 
                                     String firstName, 
                                     String lastName)
  {
    System.out.println("[ClientCreate] creating a new local Customer object");
    Customer customer = new Customer();
    customer.setId(id);
    customer.setFirstName(firstName);
    customer.setLastName(lastName);
    
    System.out.println("[ClientCreate] calling CustomerManagerBean.createCustomer() with Customer ("+customer+")");
    cm.createCustomer(customer);
  }
}
