package org.jboss.tutorial.entity.bean;

import java.util.Collection;

import javax.ejb.Remote;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

@Stateless
@Remote(CustomerManager.class)
public class CustomerManagerBean 
  implements CustomerManager 
{
  // TODO4: inject an entityManager for the persistence context "lab-entity-demo4"
  private EntityManager entityManager;
  
  public void createCustomer(Customer c) 
  {
    System.out.println("[CustomerManagerBean] createCustomer("+c+")");
    
    entityManager.persist(c);
    entityManager.flush();
  }
  
  public Customer findCustomer(int id) 
  {
    System.out.println("[CustomerManagerBean] findCustomer("+id+")");  
    
    // TODO5: use the entityManager to return the Customer with the appropriate ID
    return null;
  }
  
  public Collection<Customer> findCustomerByName(String nameToBeFound) 
  {   	  
    System.out.println("[CustomerManagerBean] findCustomerByName("+nameToBeFound+")");
    
    Query query = entityManager.createQuery("SELECT c from Customer c where UPPER(c.lastName) like :soughtAfterName");
    query.setParameter("soughtAfterName",nameToBeFound);
   
    return (Collection<Customer>) query.getResultList();
  }
   
  public void removeCustomer(int id) 
  {
    System.out.println("[CustomerManagerBean] removeCustomer("+id+")");      
    
    Customer toBeRemovedCustomer = findCustomer(id);
    this.removeCustomer(toBeRemovedCustomer);
  }
  
  private void removeCustomer(Customer c) 
  {
    System.out.println("[CustomerManagerBean] removeCustomer("+c+")");      
    
    entityManager.remove(c);
    entityManager.flush();
  }
  
  public Collection<Customer> findAllCustomers() 
  {
    System.out.println("[CustomerManagerBean] findAllCustomers()");  
    
    Query query = entityManager.createQuery("SELECT c FROM Customer c");
    return (Collection<Customer>) query.getResultList();
  }
}

