package org.jboss.tutorial.entity.client;

import java.util.Collection;

import javax.naming.InitialContext;

import org.jboss.tutorial.entity.bean.Customer;
import org.jboss.tutorial.entity.bean.CustomerManager;

public class ClientFind
{
  public static void main(String[] args) throws Exception
  {
    // Obtain a reference to the remote CustomerManagerBean
    InitialContext ctx = new InitialContext();
    CustomerManager cm = (CustomerManager) ctx.lookup("CustomerManagerBean/remote");
    
    // Find the customer with the id '3'
    System.out.println("[ClientFind] finding the customer with the id 3");
    Customer myCustomer = cm.findCustomer(3);
    
    if (myCustomer == null)
    {
      System.out.println("[ClientFind] not found.");
    }
    else
    {
      System.out.println("[ClientFind] found " + myCustomer);
    }

    // Find all customers whose surname begins with "S"
    System.out.println("[ClientFind] finding all customers whose surname begins with S");    
    Collection<Customer> customers = cm.findCustomerByName("S%");   
    for(Customer c : customers) 
    {
      System.out.println("[ClientFind] found " + c);
    }
  }
}
