package org.jboss.tutorial.interceptor;

// Imports and Dependencies
import javax.interceptor.InvocationContext;

public class LoggingInterceptor
{
  // TODO2: annotate this method to indicate it is an interceptor method
  // TODO1: edit METHOD_NAME to the more friendly "log"
  public Object METHOD_NAME(InvocationContext ctx)
    throws Exception
  {
    // This block of code is executed before the EJB method
    long startTime = System.currentTimeMillis();
    // This block of code is executed before the EJB method
    
    try
    {
      // This block of code calls the EJB method (or the next interceptor)
        //TODO3 pass control onto the next stage with "return ctx.proceed()";
      // This block of code calls the EJB method (or the next interceptor)
    }
    catch(Exception ex)
    {
      throw ex;
    }
    finally
    {
      // This block of code is executed after the EJB method
      long endTime = System.currentTimeMillis();
      long methodTime = startTime - endTime;
      String className = ctx.getTarget().getClass().getName();
      String methodName = ctx.getMethod().getName();
      //TODO4: obtain the method parameters for the intercepted method
      Object[] parameters = null;

      System.out.println(getLogString(methodTime, className, methodName, parameters));
      // This block of code is executed after the EJB method      
    }
  }
  
  // Convert a className, methodName and set of parameters into a nicely
  // formatted String
  private String getLogString(long methodTime,
                              String className, 
                              String methodName,
                              Object[] parameters)
  {
      StringBuffer logString = new StringBuffer();
      
      logString.append("["+className+"] "+methodName+"(");
      if (parameters != null)
      {
        for (int i = 0; i < parameters.length; i++)
        {
          logString.append(parameters[i]);
          if (i < parameters.length - 1)
          {
            logString.append(", ");
          }
        }
      }
      logString.append(") - "+methodTime+"ms");
      
      return logString.toString();
  }                              
}
